using MonoSoftware.MonoX.Resources;
using MonoSoftware.Web;
using MonoSoftware.Web.Pager;
using System;
using System.Web;
using System.Web.UI;

namespace MonoSoftware.MonoX.Controls
{
    /// <summary>
    /// MonoX dynamic pager template class.
    /// </summary>
    public class DynamicPagerTemplate : MonoXPagerTemplate 
    {
        #region Fields
        /// <summary>
        /// lnkMore control.
        /// </summary>
        protected System.Web.UI.WebControls.LinkButton lnkMore;
        /// <summary>
        /// Field state.
        /// </summary>
        protected System.Web.UI.WebControls.HiddenField fieldState;
        #endregion

        #region Properties
        /// <summary>
        /// Gets or sets the more link caption.
        /// </summary>
        public string MoreText { get; set; }        
        #endregion

        #region Constructor
        /// <summary>
        /// Constructor.
        /// </summary>
        public DynamicPagerTemplate()
            : base()
        {
            MoreText = "View more"; //Note: This string is not localized because this is only a sample class.
        }
        #endregion

        #region Methods

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            this.Pager.PageIndexChanging += new PageChangingEventHandler(Pager_PageIndexChanging);
            this.Page.PreRenderComplete += new EventHandler(Page_PreRenderComplete);
        }

        void Pager_PageIndexChanging(object source, PageChangingEventArgs e)
        {
            this.Pager.PageSize = Convert.ToInt32(fieldState.Value) + this.Pager.PageSize;
            e.NewPageIndex = 0;
        }

        void Page_PreRenderComplete(object sender, EventArgs e)
        {
            lnkMore.Text = MoreText;
            fieldState.Value = this.Pager.PageSize.ToString();
        }

       
        #endregion
    }
}
